// -*- c-basic-offset: 4; related-file-name: "../../lib/integers.cc" -*-
#ifndef CLICK_INTEGERS_HH
#define CLICK_INTEGERS_HH
CLICK_DECLS

#ifdef HAVE_INT64_TYPES

inline uint64_t htonq(uint64_t x) {
    uint32_t hi = x >> 32;
    uint32_t lo = x & 0xffffffff;
    return (((uint64_t)htonl(lo)) << 32) | htonl(hi);
}

inline uint64_t ntohq(uint64_t x) {
    uint32_t hi = x >> 32;
    uint32_t lo = x & 0xffffffff;
    return (((uint64_t)ntohl(lo)) << 32) | ntohl(hi);
}

#endif

// MSB is bit #1
int first_bit_set(uint32_t);
#ifdef HAVE_INT64_TYPES
int first_bit_set(uint64_t);
#endif

uint32_t int_sqrt(uint32_t);
#if HAVE_INT64_TYPES && !CLICK_LINUXMODULE
uint64_t int_sqrt(uint64_t);
#endif

CLICK_ENDDECLS
#endif
